#include <iostream>
using namespace std;
#include <limits>     // inclusion pour numeric_limits

const int MAXTAILLECHAINE = 16;  // taille max des chanes
int NBELEVES;                    // nombre d'lves dans la classe

// Structure Elve :
struct Eleve
{
    char nom[MAXTAILLECHAINE];     // Nom de famille
    char prenom[MAXTAILLECHAINE];  // Prnom de l'lve
    float moyenne;                 // Moyenne de l'lve
};

// Fonction principale
void main(void)
{
    // Entrez la valeur de la taille du tableau :
    cout << "Entrez le nombre d'eleves de la classe : ";
    cin >> NBELEVES;
    
    // Un nombre d'lve infrieur  1 serait aberrant
    while(NBELEVES<=1) {
        cout << "Erreur ! Le nombre d'eleve doit etre "
             << "strictement superieur a 1 : ";
        cin >> NBELEVES;
    }

    // Allocation dynamique du tableau :
    Eleve *tab = new Eleve[NBELEVES];
    
    // Si l'allocation n'est pas possible,
    // arrt du programme
    if(tab == NULL) {
        cout << "Erreur lors de l'allocation "
             << "du tableau d'eleves !" << endl;
        system("pause");
        exit(0);
    }

    cout << endl << "Saisie du nom, prenom et moyenne des "
         << NBELEVES << " eleves de la classe :" << endl;



    // parcours des lves un par un
    for(int i=0; i<NBELEVES; i++)
    {
        /* Saisie du Nom */
        cout << "Entrez le nom : ";
        cin >> ws;
        cin.get(tab[i].nom, MAXTAILLECHAINE);

        // Vide le tampon de cin :
        cin.clear();
        cin.ignore(numeric_limits<streamsize>::max(),'\n');

        /* Saisie du Prnom */
        cout << "Entrez le prenom : ";
        cin >> ws;
        cin.get(tab[i].prenom, MAXTAILLECHAINE);

        // Vide le tampon de cin :
        cin.clear();
        cin.ignore(numeric_limits<streamsize>::max(),'\n');

        /* Saisie de la Moyenne */
        cout << "Entrez la moyenne : ";
        cin >> tab[i].moyenne;

        // Force la moyenne  tre comprise entre 0 et 20
        while(tab[i].moyenne < 0 || tab[i].moyenne > 20) {
            cout << "Valeur incorrecte ! "
                 << "Veuillez la saisir a nouveau : ";
            cin >> tab[i].moyenne;  // On relit la moyenne
        }

        /* Affichage d'un rcapitulatif */
        cout << "L'eleve " << tab[i].nom << " " 
             << tab[i].prenom << " a " << tab[i].moyenne
             << " de moyenne." << endl;

        system("pause");    // pause
    }

    cout << "Fin de la saisie des " << NBELEVES 
         << " eleves." << endl;
    system("pause");    // pause

    // Fin du programme :
    delete [] tab; // libre la mmoire du tableau
}
