// morpion.cpp: fichier projet principal.

#include "stdafx.h"
#include "joueur.h"
#include "Form1.h"


using namespace morpion;

[STAThreadAttribute]
int main(array<System::String ^> ^args)
{
	// Activation des effets visuels de WindowsXP avant la cration de tout contrle
	Application::EnableVisualStyles();
	Application::SetCompatibleTextRenderingDefault(false); 

	// Crer la fentre principale et l'excuter
	Application::Run(gcnew Form1());
	return 0;
}

// morpion.cpp
// Implmentez le corps de la fonction ici
namespace morpion
{
	Void Form1::clicBoutonQuitter (Object^ sender, EventArgs^ e)
	{
		Close ();
	}
	Void Form1::clicBoutonNouvellePartie (Object^ sender, EventArgs^ e)
	{
		NouvellePartie ();
	}
	Void Form1::clicCase (Object^ sender, EventArgs^ e)
	{
		PictureBox^ appelant = (PictureBox^)sender;
		Point coordonnees = (Point)appelant->Tag;

		// quitte la fonction si la case comporte dj une marque
		if ( grille [ coordonnees.X, coordonnees.Y ] != nullptr )
			return;

		// attribue la case au joueur courant
		grille [ coordonnees.X, coordonnees.Y ] = joueurCourant;

		// affiche la marque du joueur dans la case
		appelant->Image = joueurCourant->propSymbole;

		// incrmente le nombre de coups joues
		coupsJoues++;


		// en cas de victoire
		if ( Alignement() == true )
		{
			// affiche une bote de dialogue
			MessageBox::Show ( joueurCourant->propNom+" remporte la manche !", "Morpion" );

			// augmente le score
			joueurCourant->propScore ++;

			// Entamme une nouvelle manche
			NouvelleManche ();
		}

		// en cas de match nul
		else if ( coupsJoues == 9 )
		{
			MessageBox::Show ( "Match nul !", "Morpion" );
			NouvelleManche ();		
		}

		// dans tous les cas, on passe la main au joueur adverse

		if ( joueurCourant == listeJoueurs[0] ) 
			PasseLaMain ( listeJoueurs[1] );
		else
			PasseLaMain ( listeJoueurs[0] );
	}

	void Form1::PasseLaMain ( Joueur^ joueur )
	{
		joueurCourant = joueur;
		labelJoueurCourant->Text = joueurCourant->propNom->ToUpper() + " JOUE";
	}

	void Form1::NouvelleManche ( void )
	{
		grille = gcnew array<Joueur^, 2>(3,3);

		for each ( Joueur^ %caseGrille in grille ) 
			caseGrille = nullptr;

		case_0_0->Image = nullptr;
		case_1_0->Image = nullptr;
		case_2_0->Image = nullptr;
		case_0_1->Image = nullptr;
		case_1_1->Image = nullptr;
		case_2_1->Image = nullptr;
		case_0_2->Image = nullptr;
		case_1_2->Image = nullptr;
		case_2_2->Image = nullptr;

		coupsJoues = 0;
	}

	void Form1::NouvellePartie ( void )
	{
		listeJoueurs = gcnew array<Joueur^>(2);

		listeJoueurs[0] = gcnew Joueur ( "Julien", listeImages->Images[0], labelScoreJoueur1 ); 
		listeJoueurs[1] = gcnew Joueur ( "Yannick", listeImages->Images[1], labelScoreJoueur2 ); 

		labelNomJoueur1->Text = listeJoueurs[0]->propNom;
		labelNomJoueur2->Text = listeJoueurs[1]->propNom;

		PasseLaMain ( listeJoueurs[0] );

		NouvelleManche ();
	}
	bool Form1::Alignement ( void )
	{
		// cherche un alignement sur une ligne

		for ( int ligne=0; ligne<3; ligne++ )
		{
			if (	grille[0,ligne] == joueurCourant &&
					grille[1,ligne] == joueurCourant &&
					grille[2,ligne] == joueurCourant ) return true;
		}

		// cherche un alignement en colonne

		for ( int colonne=0; colonne<3; colonne++ )
		{
			if ( grille[colonne,0] == joueurCourant &&
				 grille[colonne,1] == joueurCourant &&
				 grille[colonne,2] == joueurCourant ) return true;
		}

		// cherche un alignement en diagonale

		if ( grille[0,0] == joueurCourant && grille[1,1] == joueurCourant && grille[2,2] == joueurCourant )
			return true;
		if ( grille[0,2] == joueurCourant && grille[1,1] == joueurCourant && grille[2,0] == joueurCourant )
			return true;

		// aucun alignement
		return false;
	}

}