#include "StdAfx.h"
namespace gouache 
{
ref class FenetreApp;
ref class Document;
ref class Vue;
}
#include "FenetreApp.h"
#include "Document.h"
#include "Vue.h"

using namespace System::IO;

namespace gouache
{
	void Document::NouvelleVue ( void )
	{
		// cration d'un nouvel objet Vue
		Vue^ nouvelle = gcnew Vue (this);

		// prcise qu'il s'agit d'une fentre fille
		nouvelle->MdiParent = app;

		// affiche la vue
		nouvelle->Show ();

		// ajout dans la liste des vues associes au document
		int indice = listeVues->Add ( nouvelle );

		// dfinit le titre de la vue
		nouvelle->Text = pvTitre + " - vue " + indice;
	}	

	Document::Document ( FenetreApp^ app, String^ fichier )
	{
		// fentre principale
		this->app = app;

		//// ouvre le fichier bitmap
		//pvBmp = gcnew Bitmap ( fichier );
		//pvLargeur = bmp->Width;
		//pvHauteur = bmp->Height;

		//// cre la surface de dessin associe au bitmap
		//graphics = Graphics::FromImage ( pvBmp );

		//// initialisation des variables
		//pvFermetureEnCours = false;
		//pvModification = false;
		
		pvNomDeFichier = fichier;
		pvTitre = Path::GetFileName ( fichier );
		pvModification = false;
		//ChangeTitre ( Path::GetFileNameWithoutExtension(fichier) );


		// cre une vue pour le document
		//numeroNouvelleVue = 1;
		listeVues = gcnew ArrayList ();
		NouvelleVue ();
	}

	Document::Document ( FenetreApp^ app, int tailleX, int tailleY )
	{
		// fentre principale
		this->app = app;

		//// cre le bitmap
		//pvLargeur = tailleX;
		//pvHauteur = tailleY;
		//pvBmp = gcnew Bitmap ( pvLargeur, pvHauteur, PixelFormat::Format24bppRgb );

		//// cre la surface de dessin associe au bitmap
		//graphics = Graphics::FromImage ( pvBmp );

		//// remplit l'image de blanc
		//graphics->FillRectangle ( Brushes::White, 0,0,pvLargeur,pvHauteur );

		//// initialisation des variables
		//pvFermetureEnCours = false;
		//pvModification = true;
		pvNomDeFichier = "";
		pvTitre = "Sans titre";
		pvModification = true;
		//ChangeTitre ( titre );

		// cre une vue pour le document
		listeVues = gcnew ArrayList ();
		//numeroNouvelleVue = 1;
		NouvelleVue();
	}

	bool Document::EnregistrerDocument ( String^ fichier )
	{
		// sauvegarde de l'image... au chapitre suivant

		// mmorise le fichier associ  l'image
		pvNomDeFichier = fichier;

		// change, s'il y a lieu, le titre des vues
		pvTitre = Path::GetFileNameWithoutExtension(fichier);

		for each (Vue^ vue in listeVues)
			vue->Text = pvTitre + " - vue " + listeVues->IndexOf(vue);

		return true;
	}

	bool Document::FermerDocument (void)
	{
		if ( !app->AutorisationFermerDocument(this) ) 
			return false;

		while ( listeVues->Count != 0 )
		{
			Vue^ vue = (Vue^)listeVues[0];
			listeVues->Remove(vue);
			vue->Close();
		}
		return true;
	}

	bool Document::AutorisationFermerVue (Vue^ vue)
	{
		// le document a dj enlev la vue de la liste
		if ( !listeVues->Contains(vue) )
			return true;

		// il s'agit de la dernire vue du document
		else if ( listeVues->Count == 1 )
		{
			// essaie de fermer le document
			return FermerDocument ();			
		}

		// le document possde au moins deux vues
		else
		{
			listeVues->Remove ( vue );
			return true;
		}
	}
}